#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1400three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 1400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1400three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three14004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three14004xi = {
                1:'0x1358y-336z',
                2:'0x27y-1399z',
                3:'1009x789y-564z',
                4:'100x384y-1342z',
                5:'1027x862y-401z',
                6:'1036x933y-115z',
                7:'1053x738y-551z',
                8:'1074x809y-388z',
                9:'1085x878y-101z',
                10:'110x1261y-597z',
                11:'110x160y-1386z',
                12:'1118x754y-374z',
                13:'1130x821y-87z',
                14:'119x1151y-954z',
                15:'124x391y-1338z',
                16:'127x165y-1384z',
                17:'13x17y-1399z',
                18:'142x1357y-309z',
                19:'143x1173y-749z',
                20:'145x168y-1382z',
                21:'149x397y-1334z',
                22:'15x82y-1397z',
                23:'163x171y-1379z',
                24:'168x1075y-879z',
                25:'16x343y-1357z',
                26:'175x400y-1329z',
                27:'177x1259y-584z',
                28:'182x171y-1377z',
                29:'19x1167y-772z',
                30:'1x41y-1399z',
                31:'201x170y-1374z',
                32:'202x403y-1325z',
                33:'206x1172y-737z',
                34:'214x1351y-295z',
                35:'220x168y-1372z',
                36:'226x1074y-868z',
                37:'229x403y-1320z',
                38:'23x28y-1399z',
                39:'23x94y-1396z',
                40:'240x164y-1369z',
                41:'243x1254y-572z',
                42:'257x401y-1316z',
                43:'268x1166y-725z',
                44:'284x1069y-857z',
                45:'285x1341y-281z',
                46:'286x398y-1311z',
                47:'310x1245y-559z',
                48:'314x393y-1306z',
                49:'31x106y-1395z',
                50:'331x1158y-713z',
                51:'342x1060y-846z',
                52:'343x385y-1301z',
                53:'34x37y-1399z',
                54:'355x1327y-268z',
                55:'35x355y-1353z',
                56:'372x376y-1295z',
                57:'376x1232y-546z',
                58:'393x1145y-701z',
                59:'400x1049y-835z',
                60:'401x365y-1290z',
                61:'425x1309y-254z',
                62:'429x352y-1285z',
                63:'42x118y-1394z',
                64:'43x1259y-610z',
                65:'442x1216y-533z',
                66:'455x1130y-689z',
                67:'457x336y-1279z',
                68:'458x1034y-824z',
                69:'45x45y-1398z',
                70:'485x319y-1273z',
                71:'494x1287y-240z',
                72:'4x55y-1398z',
                73:'4x6y-1399z',
                74:'507x1196y-520z',
                75:'515x1016y-812z',
                76:'517x1110y-677z',
                77:'53x128y-1393z',
                78:'55x366y-1350z',
                79:'561x1262y-226z',
                80:'571x1172y-507z',
                81:'572x994y-801z',
                82:'577x1088y-664z',
                83:'58x51y-1397z',
                84:'627x970y-790z',
                85:'628x1232y-213z',
                86:'634x1145y-494z',
                87:'637x1062y-652z',
                88:'66x138y-1391z',
                89:'682x942y-778z',
                90:'692x1200y-199z',
                91:'695x1032y-640z',
                92:'696x1114y-481z',
                93:'71x1360y-322z',
                94:'72x57y-1396z',
                95:'735x911y-766z',
                96:'752x999y-627z',
                97:'755x1163y-185z',
                98:'756x1080y-468z',
                99:'77x376y-1346z',
                100:'787x877y-754z',
                101:'807x963y-615z',
                102:'80x146y-1389z',
                103:'815x1043y-455z',
                104:'816x1124y-171z',
                105:'81x1172y-761z',
                106:'837x840y-743z',
                107:'861x924y-602z',
                108:'86x61y-1395z',
                109:'871x1002y-441z',
                110:'875x1081y-157z',
                111:'885x800y-731z',
                112:'912x882y-589z',
                113:'925x958y-428z',
                114:'931x1034y-143z',
                115:'932x757y-719z',
                116:'95x154y-1388z',
                117:'962x837y-577z',
                118:'976x711y-707z',
                119:'977x911y-415z',
                120:'985x985y-129z',
                121:'9x69y-1398z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1400three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire1400three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE14000THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE14000THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE14000THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE14000THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE14000THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three14004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE14000THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE14000THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE14000THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three14004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three14004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE14000THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE14000THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE14000THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1400three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                